************************************************************************
*
* PCG: Preconditioned Conjugate Gradient Package
* Version: f77
*
************************************************************************
************************************************************************
*# 
*#                      COPYRIGHT/DISCLAIMER NOTICE
*#
*# This program was prepared by the Regents of the University of
*# California at Los Alamos National Laboratory under Contract No.
*# W-7405-ENG-36 with the U.S. Department of Energy (DOE), and by
*# the University of Texas at Austin under ARPA Contract No.
*# DABT63-92-C-0024.
*# 
*# The University of California and the University of Texas at
*# Austin have certain rights in the program pursuant to these
*# contracts.
*# 
*# Permission is hereby granted to use the program for the user's
*# own internal use.  The user is not granted the right to reproduce,
*# prepare derivative works, or redistribute the program without
*# prior permission of the University of California or the University
*# of Texas at Austin.
*# 
*# All rights in the program are reserved by the University of
*# California and the University of Texas at Austin.
*# 
*# Portions of this material resulted from work developed under a
*# U.S. Government Contract and are subject to the following
*# license: the Government is granted for itself and others acting
*# on its behalf a paid-up, nonexclusive, irrevocable worldwide
*# license in this computer software to reproduce, prepare derivative
*# works, and perform publicly and display publicly.
*# 
*# Neither the U.S. Government, the University of California nor
*# the University of Texas at Austin, nor any of their employees,
*# makes any warranty, express or implied, or assumes any liability
*# or responsibility for the use of this software.
*# 
*# Copyright (c) 1992-1995 the University of California and the
*# University of Texas at Austin.
*# 
************************************************************************
************************************************************************
************************************************************************
** ^ROUTINE:  ilog2 - integer log (base 2) function. (^)
**
************************************************************************
**
      integer function ilog2 (n)
**
************************************************************************
**
** ^DESCRIPTION:
**    Returns the ceiling of the base-2 log of an integer.
**
** ^AUTHOR:   wdj@beta.lanl.gov
**
** ^MODIFIED: wdj@lanl.gov Mon Aug 28 19:20:55 MDT 1995
**
** ^ARGUMENTS: see *Subroutine Arguments* below.
**
** ^REQUIREMENTS:
**    Common Blocks: none
**    Subroutines:   none
**
** ^SIDE_EFFECTS:
**
** ^MACROS:
**
************************************************************************
*
*     implicit character*1 (a-z)
      integer n
      integer ntemp
      integer nret
*
****^^******************************************************************
*     $Modified: wdj@lanl.gov Mon Aug 28 19:20:55 MDT 1995
*     $Id: ilog2.fm4,v 1.5 1994/02/04 03:02:55 joubert Exp $
*     $Revision: 1.0 $
************************************************************************
*
      ntemp = n
      nret = 0
 1    continue
      if (ntemp .le. 1) go to 2
      nret = nret + 1
      ntemp = (ntemp+1) / 2
      go to 1
 2    continue
      ilog2 = nret
      return
      end
